/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the ApplicationInfo type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ApplicationInfo{}

// ApplicationInfo struct for ApplicationInfo
type ApplicationInfo struct {
	Id                    NullableString `json:"id,omitempty"`
	ApplicationIdentifier NullableString `json:"applicationIdentifier,omitempty"`
	DisplayName           NullableString `json:"displayName,omitempty"`
	Description           NullableString `json:"description,omitempty"`
	HomePage              NullableString `json:"homePage,omitempty"`
}

// NewApplicationInfo instantiates a new ApplicationInfo object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewApplicationInfo() *ApplicationInfo {
	this := ApplicationInfo{}
	return &this
}

// NewApplicationInfoWithDefaults instantiates a new ApplicationInfo object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewApplicationInfoWithDefaults() *ApplicationInfo {
	this := ApplicationInfo{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ApplicationInfo) GetId() string {
	if o == nil || IsNil(o.Id.Get()) {
		var ret string
		return ret
	}
	return *o.Id.Get()
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ApplicationInfo) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Id.Get(), o.Id.IsSet()
}

// HasId returns a boolean if a field has been set.
func (o *ApplicationInfo) HasId() bool {
	if o != nil && o.Id.IsSet() {
		return true
	}

	return false
}

// SetId gets a reference to the given NullableString and assigns it to the Id field.
func (o *ApplicationInfo) SetId(v string) {
	o.Id.Set(&v)
}

// SetIdNil sets the value for Id to be an explicit nil
func (o *ApplicationInfo) SetIdNil() {
	o.Id.Set(nil)
}

// UnsetId ensures that no value is present for Id, not even an explicit nil
func (o *ApplicationInfo) UnsetId() {
	o.Id.Unset()
}

// GetApplicationIdentifier returns the ApplicationIdentifier field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ApplicationInfo) GetApplicationIdentifier() string {
	if o == nil || IsNil(o.ApplicationIdentifier.Get()) {
		var ret string
		return ret
	}
	return *o.ApplicationIdentifier.Get()
}

// GetApplicationIdentifierOk returns a tuple with the ApplicationIdentifier field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ApplicationInfo) GetApplicationIdentifierOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.ApplicationIdentifier.Get(), o.ApplicationIdentifier.IsSet()
}

// HasApplicationIdentifier returns a boolean if a field has been set.
func (o *ApplicationInfo) HasApplicationIdentifier() bool {
	if o != nil && o.ApplicationIdentifier.IsSet() {
		return true
	}

	return false
}

// SetApplicationIdentifier gets a reference to the given NullableString and assigns it to the ApplicationIdentifier field.
func (o *ApplicationInfo) SetApplicationIdentifier(v string) {
	o.ApplicationIdentifier.Set(&v)
}

// SetApplicationIdentifierNil sets the value for ApplicationIdentifier to be an explicit nil
func (o *ApplicationInfo) SetApplicationIdentifierNil() {
	o.ApplicationIdentifier.Set(nil)
}

// UnsetApplicationIdentifier ensures that no value is present for ApplicationIdentifier, not even an explicit nil
func (o *ApplicationInfo) UnsetApplicationIdentifier() {
	o.ApplicationIdentifier.Unset()
}

// GetDisplayName returns the DisplayName field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ApplicationInfo) GetDisplayName() string {
	if o == nil || IsNil(o.DisplayName.Get()) {
		var ret string
		return ret
	}
	return *o.DisplayName.Get()
}

// GetDisplayNameOk returns a tuple with the DisplayName field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ApplicationInfo) GetDisplayNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.DisplayName.Get(), o.DisplayName.IsSet()
}

// HasDisplayName returns a boolean if a field has been set.
func (o *ApplicationInfo) HasDisplayName() bool {
	if o != nil && o.DisplayName.IsSet() {
		return true
	}

	return false
}

// SetDisplayName gets a reference to the given NullableString and assigns it to the DisplayName field.
func (o *ApplicationInfo) SetDisplayName(v string) {
	o.DisplayName.Set(&v)
}

// SetDisplayNameNil sets the value for DisplayName to be an explicit nil
func (o *ApplicationInfo) SetDisplayNameNil() {
	o.DisplayName.Set(nil)
}

// UnsetDisplayName ensures that no value is present for DisplayName, not even an explicit nil
func (o *ApplicationInfo) UnsetDisplayName() {
	o.DisplayName.Unset()
}

// GetDescription returns the Description field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ApplicationInfo) GetDescription() string {
	if o == nil || IsNil(o.Description.Get()) {
		var ret string
		return ret
	}
	return *o.Description.Get()
}

// GetDescriptionOk returns a tuple with the Description field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ApplicationInfo) GetDescriptionOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Description.Get(), o.Description.IsSet()
}

// HasDescription returns a boolean if a field has been set.
func (o *ApplicationInfo) HasDescription() bool {
	if o != nil && o.Description.IsSet() {
		return true
	}

	return false
}

// SetDescription gets a reference to the given NullableString and assigns it to the Description field.
func (o *ApplicationInfo) SetDescription(v string) {
	o.Description.Set(&v)
}

// SetDescriptionNil sets the value for Description to be an explicit nil
func (o *ApplicationInfo) SetDescriptionNil() {
	o.Description.Set(nil)
}

// UnsetDescription ensures that no value is present for Description, not even an explicit nil
func (o *ApplicationInfo) UnsetDescription() {
	o.Description.Unset()
}

// GetHomePage returns the HomePage field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ApplicationInfo) GetHomePage() string {
	if o == nil || IsNil(o.HomePage.Get()) {
		var ret string
		return ret
	}
	return *o.HomePage.Get()
}

// GetHomePageOk returns a tuple with the HomePage field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ApplicationInfo) GetHomePageOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.HomePage.Get(), o.HomePage.IsSet()
}

// HasHomePage returns a boolean if a field has been set.
func (o *ApplicationInfo) HasHomePage() bool {
	if o != nil && o.HomePage.IsSet() {
		return true
	}

	return false
}

// SetHomePage gets a reference to the given NullableString and assigns it to the HomePage field.
func (o *ApplicationInfo) SetHomePage(v string) {
	o.HomePage.Set(&v)
}

// SetHomePageNil sets the value for HomePage to be an explicit nil
func (o *ApplicationInfo) SetHomePageNil() {
	o.HomePage.Set(nil)
}

// UnsetHomePage ensures that no value is present for HomePage, not even an explicit nil
func (o *ApplicationInfo) UnsetHomePage() {
	o.HomePage.Unset()
}

func (o ApplicationInfo) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ApplicationInfo) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.Id.IsSet() {
		toSerialize["id"] = o.Id.Get()
	}
	if o.ApplicationIdentifier.IsSet() {
		toSerialize["applicationIdentifier"] = o.ApplicationIdentifier.Get()
	}
	if o.DisplayName.IsSet() {
		toSerialize["displayName"] = o.DisplayName.Get()
	}
	if o.Description.IsSet() {
		toSerialize["description"] = o.Description.Get()
	}
	if o.HomePage.IsSet() {
		toSerialize["homePage"] = o.HomePage.Get()
	}
	return toSerialize, nil
}

type NullableApplicationInfo struct {
	value *ApplicationInfo
	isSet bool
}

func (v NullableApplicationInfo) Get() *ApplicationInfo {
	return v.value
}

func (v *NullableApplicationInfo) Set(val *ApplicationInfo) {
	v.value = val
	v.isSet = true
}

func (v NullableApplicationInfo) IsSet() bool {
	return v.isSet
}

func (v *NullableApplicationInfo) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableApplicationInfo(val *ApplicationInfo) *NullableApplicationInfo {
	return &NullableApplicationInfo{value: val, isSet: true}
}

func (v NullableApplicationInfo) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableApplicationInfo) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
